Index: trunk/source/App/TAppEncoder/TAppEncTop.cpp
===================================================================
--- trunk/source/App/TAppEncoder/TAppEncTop.cpp	(revision 42)
+++ trunk/source/App/TAppEncoder/TAppEncTop.cpp	(revision 56)
@@ -329,5 +460,21 @@
       m_acTEncDepthTopList[iViewIdx]->setQuadtreeTUMaxDepthIntra      ( m_uiQuadtreeTUMaxDepthIntra );
       m_acTEncDepthTopList[iViewIdx]->setUseFastEnc                   ( m_bUseFastEnc  );
-
+      m_acTEncDepthTopList[iViewIdx]->setUseEarlyCU                   ( m_bUseEarlyCU  ); 
+#if FAST_DECISION_FOR_MRG_RD_COST
+      m_acTEncDepthTopList[iViewIdx]->setUseFastDecisionForMerge      ( m_useFastDecisionForMerge  );
+#endif
+      m_acTEncDepthTopList[iViewIdx]->setUseCbfFastMode               ( m_bUseCbfFastMode  );
+#if HHI_INTERVIEW_SKIP
+      m_acTEncDepthTopList[iViewIdx]->setInterViewSkip            ( 0 );
+#if HHI_INTERVIEW_SKIP_LAMBDA_SCALE
+      m_acTEncDepthTopList[iViewIdx]->setInterViewSkipLambdaScale ( 1 );
+#endif
+#endif
+      m_acTEncDepthTopList[iViewIdx]->setUseLMChroma                  ( m_bUseLMChroma );
+      m_acTEncDepthTopList[iViewIdx]->setUseConstrainedIntraPred      ( m_bUseConstrainedIntraPred );
+      m_acTEncDepthTopList[iViewIdx]->setPCMLog2MinSize               ( m_uiPCMLog2MinSize);
+      m_acTEncDepthTopList[iViewIdx]->setUsePCM                       ( m_usePCM );
+      m_acTEncDepthTopList[iViewIdx]->setPCMLog2MaxSize               ( m_pcmLog2MaxSize);
+      //====== VSO ========
 #if HHI_VSO
       m_acTEncDepthTopList[iViewIdx]->setUseVSO                       ( m_bUseVSO      ); //GT: might be enabled/disabled later for VSO Mode 4
@@ -340,14 +487,4 @@
 #endif
 
-#if BITSTREAM_EXTRACTION
-      m_acTEncDepthTopList[iViewIdx]->setLayerId                      ( ( ( (UInt)iViewIdx ) << 1 ) + 1 );
-#endif
-      m_acTEncDepthTopList[iViewIdx]->setViewId                       ( (UInt)iViewIdx );
-      m_acTEncDepthTopList[iViewIdx]->setViewOrderIdx                 ( m_cCameraData.getViewOrderIndex()[ iViewIdx ] );
-      m_acTEncDepthTopList[iViewIdx]->setIsDepth                      ( true );
-      m_acTEncDepthTopList[iViewIdx]->setCamParPrecision              ( 0 );
-      m_acTEncDepthTopList[iViewIdx]->setCamParInSliceHeader          ( false );
-      m_acTEncDepthTopList[iViewIdx]->setCodedScale                   ( 0 );
-      m_acTEncDepthTopList[iViewIdx]->setCodedOffset                  ( 0 );
 #if DEPTH_MAP_GENERATION
       m_acTEncDepthTopList[iViewIdx]->setPredDepthMapGeneration       ( 0 );
@@ -362,68 +499,106 @@
 #endif
 
-#if HHI_INTERVIEW_SKIP
-      m_acTEncDepthTopList[iViewIdx]->setInterViewSkip            ( 0 );
-#if HHI_INTERVIEW_SKIP_LAMBDA_SCALE
-      m_acTEncDepthTopList[iViewIdx]->setInterViewSkipLambdaScale ( 1 );
-#endif
-#endif
-      m_acTEncDepthTopList[iViewIdx]->setUseMRG                       ( m_bUseMRG      ); // SOPH:
-
-#if LM_CHROMA
-      m_acTEncDepthTopList[iViewIdx]->setUseLMChroma                  ( m_bUseLMChroma );
-#endif
-
-#if HHI_RMP_SWITCH
-      m_acTEncDepthTopList[iViewIdx]->setUseRMP                     ( m_bUseRMP );
-#endif
-#ifdef ROUNDING_CONTROL_BIPRED
-      m_acTEncDepthTopList[iViewIdx]->setUseRoundingControlBipred(m_useRoundingControlBipred);
-#endif
+      //====== Weighted Prediction ========
+      m_acTEncDepthTopList[iViewIdx]->setUseWP                        ( m_bUseWeightPred      );
+      m_acTEncDepthTopList[iViewIdx]->setWPBiPredIdc                  ( m_uiBiPredIdc         );
+      //====== Slice ========
+      m_acTEncDepthTopList[iViewIdx]->setSliceMode                    ( m_iSliceMode                );
+      m_acTEncDepthTopList[iViewIdx]->setSliceArgument                ( m_iSliceArgument            );
+
+      //====== Entropy Slice ========
+      m_acTEncDepthTopList[iViewIdx]->setEntropySliceMode             ( m_iEntropySliceMode         );
+      m_acTEncDepthTopList[iViewIdx]->setEntropySliceArgument         ( m_iEntropySliceArgument     );
+      int iNumPartInCU = 1<<(m_uiMaxCUDepth<<1);
+      if(m_iEntropySliceMode==SHARP_FIXED_NUMBER_OF_LCU_IN_ENTROPY_SLICE)
+      {
+        m_acTEncDepthTopList[iViewIdx]->setEntropySliceArgument ( m_iEntropySliceArgument * ( iNumPartInCU >> ( m_iSliceGranularity << 1 ) ) );
+      }
+      if(m_iSliceMode==AD_HOC_SLICES_FIXED_NUMBER_OF_LCU_IN_SLICE)
+      {
+        m_acTEncDepthTopList[iViewIdx]->setSliceArgument ( m_iSliceArgument * ( iNumPartInCU >> ( m_iSliceGranularity << 1 ) ) );
+      }
+#if FIXED_NUMBER_OF_TILES_SLICE_MODE
+      if(m_iSliceMode==AD_HOC_SLICES_FIXED_NUMBER_OF_TILES_IN_SLICE)
+      {
+        m_acTEncDepthTopList[iViewIdx]->setSliceArgument ( m_iSliceArgument );
+      }
+#endif
+      m_acTEncDepthTopList[iViewIdx]->setSliceGranularity        ( m_iSliceGranularity         );
+      if(m_iSliceMode == 0 )
+      {
+        m_bLFCrossSliceBoundaryFlag = true;
+      }
+      m_acTEncDepthTopList[iViewIdx]->setLFCrossSliceBoundaryFlag( m_bLFCrossSliceBoundaryFlag );
+      m_acTEncDepthTopList[iViewIdx]->setUseSAO               ( m_abUseSAO[1]     );
+#if SAO_UNIT_INTERLEAVING
+      m_acTEncDepthTopList[iViewIdx]->setMaxNumOffsetsPerPic (m_maxNumOffsetsPerPic);
+      m_acTEncDepthTopList[iViewIdx]->setSaoInterleavingFlag (m_saoInterleavingFlag);
+#endif
+      m_acTEncDepthTopList[iViewIdx]->setPCMInputBitDepthFlag  ( m_bPCMInputBitDepthFlag); 
+      m_acTEncDepthTopList[iViewIdx]->setPCMFilterDisableFlag  ( m_bPCMFilterDisableFlag); 
+
+      m_acTEncDepthTopList[iViewIdx]->setPictureDigestEnabled(m_pictureDigestEnabled);
+
+      m_acTEncDepthTopList[iViewIdx]->setColumnRowInfoPresent       ( m_iColumnRowInfoPresent );
+      m_acTEncDepthTopList[iViewIdx]->setUniformSpacingIdr          ( m_iUniformSpacingIdr );
+#if !REMOVE_TILE_DEPENDENCE
+      m_acTEncDepthTopList[iViewIdx]->setTileBoundaryIndependenceIdr( m_iTileBoundaryIndependenceIdr );
+#endif
+      m_acTEncDepthTopList[iViewIdx]->setNumColumnsMinus1           ( m_iNumColumnsMinus1 );
+      m_acTEncDepthTopList[iViewIdx]->setNumRowsMinus1              ( m_iNumRowsMinus1 );
+      if(m_iUniformSpacingIdr==0)
+      {
+        m_acTEncDepthTopList[iViewIdx]->setColumnWidth              ( m_pchColumnWidth );
+        m_acTEncDepthTopList[iViewIdx]->setRowHeight                ( m_pchRowHeight );
+      }
+      m_acTEncDepthTopList[iViewIdx]->xCheckGSParameters();
+      m_acTEncDepthTopList[iViewIdx]->setTileLocationInSliceHeaderFlag ( m_iTileLocationInSliceHeaderFlag );
+      m_acTEncDepthTopList[iViewIdx]->setTileMarkerFlag              ( m_iTileMarkerFlag );
+      m_acTEncDepthTopList[iViewIdx]->setMaxTileMarkerEntryPoints    ( m_iMaxTileMarkerEntryPoints );
+
+      Int uiTilesCount          = (m_iNumRowsMinus1+1) * (m_iNumColumnsMinus1+1);
+      m_dMaxTileMarkerOffset    = ((Double)uiTilesCount) / m_iMaxTileMarkerEntryPoints;
+      m_acTEncDepthTopList[iViewIdx]->setMaxTileMarkerOffset         ( m_dMaxTileMarkerOffset );
+      m_acTEncDepthTopList[iViewIdx]->setTileBehaviorControlPresentFlag( m_iTileBehaviorControlPresentFlag );
+#if !REMOVE_TILE_DEPENDENCE
+      if(m_iTileBoundaryIndependenceIdr == 0 || uiTilesCount == 1)
+#else
+      if(uiTilesCount == 1)
+#endif
+      {
+        m_bLFCrossTileBoundaryFlag = true; 
+      }
+      m_acTEncDepthTopList[iViewIdx]->setLFCrossTileBoundaryFlag( m_bLFCrossTileBoundaryFlag );
+      m_acTEncDepthTopList[iViewIdx]->setWaveFrontSynchro           ( m_iWaveFrontSynchro );
+      m_acTEncDepthTopList[iViewIdx]->setWaveFrontFlush             ( m_iWaveFrontFlush );
+      m_acTEncDepthTopList[iViewIdx]->setWaveFrontSubstreams        ( m_iWaveFrontSubstreams );
+      m_acTEncDepthTopList[iViewIdx]->setEnableTMVP ( m_enableTMVP );
+      m_acTEncDepthTopList[iViewIdx]->setUseScalingListId           ( m_useScalingListId  );
+      m_acTEncDepthTopList[iViewIdx]->setScalingListFile            ( m_scalingListFile   );
+#if MULTIBITS_DATA_HIDING
+      m_acTEncDepthTopList[iViewIdx]->setSignHideFlag(m_signHideFlag);
+      m_acTEncDepthTopList[iViewIdx]->setTSIG(m_signHidingThreshold);
+#endif
+
+#if LCU_SYNTAX_ALF
+      if(uiTilesCount > 1)
+      {
+        m_bALFParamInSlice = false;
+        m_bALFPicBasedEncode = true;
+      }
+      m_acTEncDepthTopList[iViewIdx]->setALFParamInSlice              ( m_bALFParamInSlice);
+      m_acTEncDepthTopList[iViewIdx]->setALFPicBasedEncode            ( m_bALFPicBasedEncode);
+#endif
+
+  //====== Depth tools ========
 #if HHI_DMM_WEDGE_INTRA || HHI_DMM_PRED_TEX
-      m_acTEncDepthTopList[iViewIdx]->setUseDMM( m_bUseDMM );
-#endif
-#if FLEX_CODING_ORDER && HHI_DMM_PRED_TEX
-      m_acTEncDepthTopList[iViewIdx]->setUseDMM34( (m_b3DVFlexOrder && isDepthFirst) ? false : m_bUseDMM );
-#endif
-#if CONSTRAINED_INTRA_PRED
-      m_acTEncDepthTopList[iViewIdx]->setUseConstrainedIntraPred      ( m_bUseConstrainedIntraPred );
-#endif
-#ifdef WEIGHT_PRED
-    //====== Weighted Prediction ========
-      m_acTEncDepthTopList[iViewIdx]->setUseWP                         ( m_bUseWeightPred      );
-      m_acTEncDepthTopList[iViewIdx]->setWPBiPredIdc                   ( m_uiBiPredIdc         );
-#endif
-      //====== Slice ========
-      m_acTEncDepthTopList[iViewIdx]->setSliceMode               ( m_iSliceMode                );
-      m_acTEncDepthTopList[iViewIdx]->setSliceArgument           ( m_iSliceArgument            );
-
-      //====== Entropy Slice ========
-      m_acTEncDepthTopList[iViewIdx]->setEntropySliceMode        ( m_iEntropySliceMode         );
-      m_acTEncDepthTopList[iViewIdx]->setEntropySliceArgument    ( m_iEntropySliceArgument     );
-#if MTK_NONCROSS_INLOOP_FILTER
-      if(m_iSliceMode == 0 )
-      {
-        m_bLFCrossSliceBoundaryFlag = true;
-      }
-      m_acTEncDepthTopList[iViewIdx]->setLFCrossSliceBoundaryFlag( m_bLFCrossSliceBoundaryFlag );
-#endif
-#if MTK_SAO
-      m_acTEncDepthTopList[iViewIdx]->setUseSAO               ( m_abUseSAO[1]     );
+    m_acTEncDepthTopList[iViewIdx]->setUseDMM                     ( m_bUseDMM );
 #endif
 #if HHI_MPI
-#if FLEX_CODING_ORDER
-      m_acTEncDepthTopList[iViewIdx]->setUseMVI( (m_b3DVFlexOrder && isDepthFirst) ? false : m_bUseMVI );
-#else
-      m_acTEncDepthTopList[iViewIdx]->setUseMVI( m_bUseMVI );
-#endif
-#endif
-      
-      m_acTEncDepthTopList[iViewIdx]->setPictureDigestEnabled(m_pictureDigestEnabled);
-
-      m_acTEncDepthTopList[iViewIdx]->setQpChangeFrame( m_iQpChangeFrame );
-      m_acTEncDepthTopList[iViewIdx]->setQpChangeOffsetVideo( m_iQpChangeOffsetVideo );
-      m_acTEncDepthTopList[iViewIdx]->setQpChangeOffsetDepth( m_iQpChangeOffsetDepth );
-    }
-  }
+     m_acTEncDepthTopList[iViewIdx]->setUseMVI( m_bUseMVI );
+#endif
+    }
+  }
+
 #if HHI_INTER_VIEW_MOTION_PRED
   else if( m_uiMultiviewMvRegMode )
@@ -466,5 +641,5 @@
     else
     {
-      m_cRendererTop.init(m_iSourceWidth, m_iSourceHeight,true,0,0,true, 0,0,0,0,0,0,0,1,0,0 );  //GT: simplest configuration
+      AOT(true);
     }
   }
@@ -474,78 +649,59 @@
   m_cUsedPelsRenderer.init(m_iSourceWidth, m_iSourceHeight, true, 0, LOG2_DISP_PREC_LUT, true, 0, 0, 0, 0, 0, 6, 4, 1, 0, 6 );
 #endif
+
 }
 
 Void TAppEncTop::xCreateLib()
 {
-  // Video I/O
-  m_cTVideoIOBitsFile.openBits( m_pchBitstreamFile, true  );  // write mode
-
   for(Int iViewIdx=0; iViewIdx<m_iNumberOfViews; iViewIdx++)
   {
     m_acTVideoIOYuvInputFileList[iViewIdx]->open( m_pchInputFileList[iViewIdx],     false, m_uiInputBitDepth, m_uiInternalBitDepth );  // read  mode
-    m_acTVideoIOYuvInputFileList[iViewIdx]->skipFrames(m_FrameSkip, m_iSourceWidth, m_iSourceHeight);
-    m_acTVideoIOYuvReconFileList[iViewIdx]->open( m_pchReconFileList[iViewIdx],     true, m_uiOutputBitDepth, m_uiInternalBitDepth);  // write mode
-
-    // Neo Decoder
+    m_acTVideoIOYuvInputFileList[iViewIdx]->skipFrames(m_FrameSkip, m_iSourceWidth - m_aiPad[0], m_iSourceHeight - m_aiPad[1]);
+
+    if (m_pchReconFileList[iViewIdx])
+      m_acTVideoIOYuvReconFileList[iViewIdx]->open(m_pchReconFileList[iViewIdx], true, m_uiOutputBitDepth, m_uiInternalBitDepth);  // write mode
     m_acTEncTopList[iViewIdx]->create();
-
     if( m_bUsingDepthMaps )
+    {
+      m_acTVideoIOYuvDepthInputFileList[iViewIdx]->open( m_pchDepthInputFileList[iViewIdx],     false, m_uiInputBitDepth, m_uiInternalBitDepth );  // read  mode
+      m_acTVideoIOYuvDepthInputFileList[iViewIdx]->skipFrames(m_FrameSkip, m_iSourceWidth - m_aiPad[0], m_iSourceHeight - m_aiPad[1]);
+
+      if (m_pchDepthReconFileList[iViewIdx])
+        m_acTVideoIOYuvDepthReconFileList[iViewIdx]->open(m_pchDepthReconFileList[iViewIdx], true, m_uiOutputBitDepth, m_uiInternalBitDepth);  // write mode
+      m_acTEncDepthTopList[iViewIdx]->create();
+    }
+#if HHI_INTER_VIEW_MOTION_PRED
+    else if( m_uiMultiviewMvRegMode )
     {
       m_acTVideoIOYuvDepthInputFileList[iViewIdx]->open( m_pchDepthInputFileList[iViewIdx],     false, m_uiInputBitDepth, m_uiInternalBitDepth );  // read  mode
       m_acTVideoIOYuvDepthInputFileList[iViewIdx]->skipFrames(m_FrameSkip, m_iSourceWidth, m_iSourceHeight);
-
-      m_acTVideoIOYuvDepthReconFileList[iViewIdx]->open( m_pchDepthReconFileList[iViewIdx],     true, m_uiOutputBitDepth, m_uiInternalBitDepth);  // write mode
-
-      // Neo Decoder
-      m_acTEncDepthTopList[iViewIdx]->create();
-    }
-#if HHI_INTER_VIEW_MOTION_PRED
-    else if( m_uiMultiviewMvRegMode )
-    {
-      m_acTVideoIOYuvDepthInputFileList[iViewIdx]->open( m_pchDepthInputFileList[iViewIdx],     false, m_uiInputBitDepth, m_uiInternalBitDepth );  // read  mode
-      m_acTVideoIOYuvDepthInputFileList[iViewIdx]->skipFrames(m_FrameSkip, m_iSourceWidth, m_iSourceHeight);
-    }
-#endif
-  }
-
-#if HHI_VSO
-  for(Int iViewIdx=0; iViewIdx < m_iNumberOfExternalRefs; iViewIdx++)
-  {
-    m_acTVideoIOYuvERFileList[iViewIdx]->open( m_pchERRefFileList[iViewIdx], false, m_uiInputBitDepth, m_uiInternalBitDepth ); // read mode
-  }
-#endif
+    }
+#endif
+  }
 }
 
 Void TAppEncTop::xDestroyLib()
 {
-
-  m_cTVideoIOBitsFile.closeBits();
-
-#if HHI_VSO
-  for ( Int iViewIdx = 0; iViewIdx < m_iNumberOfExternalRefs; iViewIdx++ )
-  {
-    m_acTVideoIOYuvERFileList[iViewIdx]->close();
-    delete m_acTVideoIOYuvERFileList[iViewIdx];
-    m_acTVideoIOYuvERFileList[iViewIdx] = 0;
-  };
-#endif
-
+  // Video I/O
   for(Int iViewIdx=0; iViewIdx<m_iNumberOfViews; iViewIdx++)
   {
     m_acTVideoIOYuvInputFileList[iViewIdx]->close();
     m_acTVideoIOYuvReconFileList[iViewIdx]->close();
-
-    delete m_acTVideoIOYuvInputFileList[iViewIdx] ; m_acTVideoIOYuvInputFileList[iViewIdx] = NULL;
-    delete m_acTVideoIOYuvReconFileList[iViewIdx] ; m_acTVideoIOYuvReconFileList[iViewIdx] = NULL;
-
-    delete m_cListPicYuvRecList[iViewIdx] ; m_cListPicYuvRecList[iViewIdx] = NULL;
-
+    delete m_acTVideoIOYuvInputFileList[iViewIdx] ; 
+    m_acTVideoIOYuvInputFileList[iViewIdx] = NULL;
+    delete m_acTVideoIOYuvReconFileList[iViewIdx] ; 
+    m_acTVideoIOYuvReconFileList[iViewIdx] = NULL;
+    m_acTEncTopList[iViewIdx]->deletePicBuffer();
     m_acTEncTopList[iViewIdx]->destroy();
-    delete m_acTEncTopList[iViewIdx] ; m_acTEncTopList[iViewIdx] = NULL;
+    delete m_acTEncTopList[iViewIdx] ; 
+    m_acTEncTopList[iViewIdx] = NULL;
+    delete m_picYuvRec[iViewIdx] ; 
+    m_picYuvRec[iViewIdx] = NULL;
 
     if( iViewIdx < Int( m_acTVideoIOYuvDepthInputFileList.size() ) && m_acTVideoIOYuvDepthInputFileList[iViewIdx] )
     {
       m_acTVideoIOYuvDepthInputFileList[iViewIdx]->close( );
-      delete m_acTVideoIOYuvDepthInputFileList[iViewIdx] ;
+      delete m_acTVideoIOYuvDepthInputFileList[iViewIdx];
+      m_acTVideoIOYuvDepthInputFileList[iViewIdx] = NULL;
     }
     if( iViewIdx < Int( m_acTVideoIOYuvDepthReconFileList.size() ) && m_acTVideoIOYuvDepthReconFileList[iViewIdx] )
@@ -553,13 +709,17 @@
       m_acTVideoIOYuvDepthReconFileList[iViewIdx]->close () ;
       delete m_acTVideoIOYuvDepthReconFileList[iViewIdx];
+      m_acTVideoIOYuvDepthReconFileList[iViewIdx] = NULL;
     }
     if( iViewIdx < Int( m_acTEncDepthTopList.size() ) && m_acTEncDepthTopList[iViewIdx] )
     {
+      m_acTEncDepthTopList[iViewIdx]->deletePicBuffer();
       m_acTEncDepthTopList[iViewIdx]->destroy();
       delete m_acTEncDepthTopList[iViewIdx];
-    }
-    if( iViewIdx < Int( m_cListPicYuvDepthRecList.size() ) && m_cListPicYuvDepthRecList[iViewIdx] )
-    {
-      delete m_cListPicYuvDepthRecList[iViewIdx ];
+      m_acTEncDepthTopList[iViewIdx] = NULL;
+    }
+    if( iViewIdx < Int( m_picYuvDepthRec.size() ) && m_picYuvDepthRec[iViewIdx] )
+    {
+      delete m_picYuvDepthRec[iViewIdx] ; 
+      m_picYuvDepthRec[iViewIdx] = NULL;
     }
   }
@@ -601,46 +761,44 @@
  .
  */
-//GT PRE LOAD ENC BUFFER
 Void TAppEncTop::encode()
 {
-  TComPicYuv*       pcPicYuvOrg      = new TComPicYuv;
+  fstream bitstreamFile(m_pchBitstreamFile, fstream::binary | fstream::out);
+  if (!bitstreamFile)
+  {
+    fprintf(stderr, "\nfailed to open bitstream file `%s' for writing\n", m_pchBitstreamFile);
+    exit(EXIT_FAILURE);
+  }
+
+  TComPicYuv*       pcPicYuvOrg = new TComPicYuv;
   TComPicYuv*       pcDepthPicYuvOrg = new TComPicYuv;
   TComPicYuv*       pcPdmDepthOrg    = new TComPicYuv;
-  TComPicYuv*       pcPicYuvRec      = NULL;
-  //TComPicYuv*       pcDepthPicYuvRec = NULL;
-
+  TComPicYuv*       pcPicYuvRec = NULL;
+  TComPicYuv*       pcDepthPicYuvRec = NULL;
+  
   // initialize internal class & member variables
   xInitLibCfg();
   xCreateLib();
   xInitLib();
-
+  
   // main encoder loop
-
-  //GT: setup and init Bools for Eos and Continue Reading
-  Bool  bAllEos = false;
-  Bool  bAllContinueReadingPics = false;
-  std::vector<Bool>  bEos ;
-  std::vector<Bool>  bContinueReadingPics ;
-
-  Bool  bAllDepthEos = false;
-  Bool  bAllContinueReadingDepthPics = false;
-  std::vector<Bool>  bDepthEos ;
-  std::vector<Bool>  bContinueReadingDepthPics ;
+  Bool  allEos = false;
+  std::vector<Bool>  eos ;
+  std::vector<Bool>  depthEos ;
+  Int maxGopSize = 0;
+  Int gopSize = 1;
+  
+  list<AccessUnit> outputAccessUnits; ///< list of access units to write out.  is populated by the encoding process
+  maxGopSize = (std::max)(maxGopSize, m_acTEncTopList[0]->getGOPSize());   
+
   for(Int iViewIdx=0; iViewIdx < m_iNumberOfViews; iViewIdx++ )
   {
-    bEos.push_back( false ) ;
-    bContinueReadingPics.push_back( true );
-    if( m_bUsingDepthMaps)
-    {
-      bDepthEos.push_back( false ) ;
-      bContinueReadingDepthPics.push_back( true ) ;
-    }
-  }
+    eos.push_back( false );
+    depthEos.push_back( false );
+  }
+
   // allocate original YUV buffer
   pcPicYuvOrg->create( m_iSourceWidth, m_iSourceHeight, m_uiMaxCUWidth, m_uiMaxCUHeight, m_uiMaxCUDepth );
-  if( m_bUsingDepthMaps)
-  {
-    pcDepthPicYuvOrg->create( m_iSourceWidth, m_iSourceHeight, m_uiMaxCUWidth, m_uiMaxCUHeight, m_uiMaxCUDepth );
-  }
+  pcDepthPicYuvOrg->create( m_iSourceWidth, m_iSourceHeight, m_uiMaxCUWidth, m_uiMaxCUHeight, m_uiMaxCUDepth );
+
 #if HHI_INTER_VIEW_MOTION_PRED
   if( m_uiMultiviewMvRegMode )
@@ -650,25 +808,17 @@
 #endif
 
-  TComBitstream*    pcBitstream = new TComBitstream;
-  pcBitstream->create( (m_iSourceWidth * m_iSourceHeight * 3) >> 1 ) ; //GT: is size reasonable ??
-
-  while ( !(bAllEos&& bAllContinueReadingPics) )
-  {
-    bAllContinueReadingPics = false;
-    bAllContinueReadingDepthPics = false;
-
-    //GT: Read all Buffers
-    for(Int iViewIdx=0; iViewIdx < m_iNumberOfViews; iViewIdx++ ) //GT; store frames first
-    {
-      if (!bEos[iViewIdx] && bContinueReadingPics[iViewIdx] ) //GT: read frames to buffer
+  while ( !allEos )
+  {
+    for(Int iViewIdx=0; iViewIdx < m_iNumberOfViews; iViewIdx++ )
+    {
+      Int frmCnt = 0;
+      while ( !eos[iViewIdx] && !(frmCnt == gopSize))
       {
         // get buffers
-        xGetBuffer( pcPicYuvRec, iViewIdx, m_cListPicYuvRecList ); // ringbuffer of size gopsize -> m_cListPicYuvRec, m_cListBitstream
+        xGetBuffer(pcPicYuvRec, iViewIdx, false);
+
         // read input YUV file
-        m_acTVideoIOYuvInputFileList[iViewIdx]->read( pcPicYuvOrg, m_aiPad  ) ;
-        bEos[iViewIdx] = ( m_acTVideoIOYuvInputFileList[iViewIdx]->isEof() == 1 ?   true : false  );             //GT: End of File
-        bEos[iViewIdx] = ( m_iFrameRcvdVector[iViewIdx] == (m_iFrameToBeEncoded - 1) ?    true : bEos[iViewIdx]   );   //GT: FramesToBeEncoded Reached
-        bAllEos = bAllEos|bEos[iViewIdx] ;
-
+        m_acTVideoIOYuvInputFileList[iViewIdx]->read( pcPicYuvOrg, m_aiPad );
+      
 #if HHI_INTER_VIEW_MOTION_PRED
         if( m_uiMultiviewMvRegMode && iViewIdx )
